////////////////////////////////////////////////////////////////////////////////////
//
// Pgpb2Encode.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: Pgpb2Encode.cpp,v $
 * Revision 1.5  2000/11/08 16:50:47  syou
 * - PGPlogɃbZ[Wo͂邽߂ɁAclass PGPlogVK쐬B
 *   FXKvɂȂ肻Ȃ̂ŁAclass CriticalSectionVK쐬B
 *
 * Revision 1.4  2000/11/07 15:57:19  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 * Revision 1.3  2000/08/24 15:39:24  syou
 * - multipart`̃[ƂsȏA؂ł
 * 肷̃oOCBBkCommon.cpp̉~XB
 *
 * Revision 1.2  2000/08/23 22:26:45  syou
 * - ̏I[s̃oOCBBkCommon.cppABkCommon.hőΏB
 *
 * Revision 1.1  2000/08/06 15:14:42  syou
 * - message/rfc822`Ń[YtĂꍇAYtĂ郁[
 *   ǂ̑ΏۂƂȂ悤ɂBB2(beta23)ȍ~ep[g Content-Typew
 *   ƎQƂ邱ƂmFBAbeta22ȑOgč쐬ꂽ
 *   multipart[̏ꍇ́Â肭Ȃ悤ɎvB
 *   main.cpp剻߁ABclass CPgpb2ǉA
 *   Pgpb2Decode.cppAPgpb2Encode.cppAPgpb2Utility.cppɕčsB
 *   剻ABkmail2->h𕪊Bclass`BkMessage.hɏWA
 *   class CBkMessagẽCC֐BkMessage.hɁAclass CBkMailPart̃C
 *   C֐BkMailPart.hɁAclass CBkMail̃CC֐Bkmail2->hɋL
 *   qA#includeɂABkMessage.h̖Ɏ荞łB
 *   ȊÓAꂼBkMessage.cppABkMailPart.cppABkmail2->cppɎB
 *   message/rfc822`̓Yt[ɑΉ邽߁A class CBkRfc822ǉBC
 *   C֐ BkRfc822.hɋLqȂBkRfc822.cppɎBclass
 *   CBkMessage̔hNXÂNXłclass
 *   CBkMessageɈϏB
 *   Encodẽ[`̕ADecodê̂ɓB܂A
 *         CBkMailPartPtr bmpEncrypt1;
 *         bmpEncrypt1 = mail2->SetChild(new CMIMEItem());
 *
 */


#pragma warning(push)
#pragma warning(disable:4101)
#pragma warning(disable:4786)


////////////////////////////////////////////////////////////////////////
// 
#include "Pgpb2.h"
#include "stringfr.h"


////////////////////////////////////////////////////////////////////////
// PGPÍ
bool Pgpb2::encrypt(HWND hWnd, PGPContextRef context)
{
    // "To"A"Cc"A"Bcc"̊ewb_ mailaddress 𒊏oA|C^XgɊi[B
    string to = mail->getHeader("To");
    string cc = mail->getHeader("Cc");
    string bcc = mail->getHeader("Bcc");

    CPointerList lstAddr;
    addAddressList(lstAddr, to);
    addAddressList(lstAddr, cc);
    addAddressList(lstAddr, bcc);

    // i[ mailaddress Ƃ return B
    CPointerItem* pItem = lstAddr.GetTop();
    if (pItem == NULL) {
        return false;
    }

    // e mailaddress ɑΉL[܂Ƃ߂ĒoB
    PGPKeySetRef foundUserKeys = NULL;
    if (!getKeySet(pItem, context, foundUserKeys)) {
        return false;
    }

    // ÍɎgpL[I_CAO\B
    PGPError err = kPGPError_NoErr;
    PGPKeySetRef encryptKeys = NULL;
    PGPUInt32 initialValue = (pgpmime) ? TRUE : FALSE;
    PGPUInt32 resultValue;
    err = PGPRecipientDialog(
            context,
            foundUserKeys,
            TRUE,
            &encryptKeys,
            PGPOUIParentWindowHandle(context, hWnd),
            PGPOUIDialogOptions(context,
                PGPOUICheckbox(context, 1, "PGP/MIME_RFC2015", "", initialValue, &resultValue,
                    PGPOLastOption(context)),
                PGPOLastOption(context)),
            //PGPOUIDisplayMarginalValidity(context, TRUE),
            PGPOLastOption(context)
            );

    if (IsPGPError(err)) {
        if(PGPKeySetRefIsValid(foundUserKeys)) {
            PGPFreeKeySet(foundUserKeys);
        }
        if(PGPKeySetRefIsValid(encryptKeys)) {
            PGPFreeKeySet(encryptKeys);
        }
        return false;
    }

    PGPUInt32 count;
    err = PGPCountKeys(encryptKeys, &count);
    if (IsPGPError(err) || count < 1) {
        return false;
    }

    pgpmime = (resultValue == TRUE);
    string text = mail->getPgpOriginalText(hWnd, pgpmime);
    if (text.size() == 0) {
        return false;
    }
    /*
    FILE* fp;
    fp = fopen("E:\\syou\\mail1.txt", "wb");
    fwrite(text.c_str(), text.size(), 1, fp);
    fclose(fp);
    //*/

    LPSTR lpArea = NULL;
    PGPSize size;
    err = PGPEncode(
            context,
            PGPOEncryptToKeySet(context, encryptKeys),
            PGPOInputBuffer(context, text.c_str(), text.size()),
            PGPOAllocatedOutputBuffer(context, reinterpret_cast<void**>(&lpArea), MAX_PGPInt32, &size),
            PGPOVersionString(context, version.c_str()),
            PGPOArmorOutput(context, TRUE),
            PGPOLastOption(context)
            );

    if(PGPKeySetRefIsValid(foundUserKeys)) {
        PGPFreeKeySet(foundUserKeys);
    }
    if(PGPKeySetRefIsValid(encryptKeys)) {
        PGPFreeKeySet(encryptKeys);
    }
    if (IsPGPError(err) || lpArea == NULL) {
        return false;
    }

    if (pgpmime) {
        char szBoundary[1024];  // MIMEboundary ؂蕶
        char szData[8192];
        time_t t;
        time(&t);   // ݂̎擾 boundaryɖߍ
        sprintf(szBoundary, "===[PGP/MIME_RFC2015]===%08X.%04X===", (DWORD)t, &t);
        sprintf(szData, "multipart/encrypted;\r\n boundary=\"%s\";\r\n protocol=\"application/pgp-encrypted\"", szBoundary);
        mail->setHeader("Content-Type", szData);
        mail->setHeader("Content-Transfer-Encoding", "7bit");
        mail->clearBody();

        BkMail* child1 = mail->setChild(new BkMail());
        child1->setHeader("Content-Type", "application/pgp-encrypted");
        child1->setHeader("Content-Transfer-Encoding", "7bit");
        child1->pushBodyBack("Version: 1\r\n");

        BkMail* child2 = mail->addChild(new BkMail());
        child2->setHeader("Content-Type", "application/octet-stream");
        child2->setHeader("Content-Transfer-Encoding", "7bit");
        child2->pushBodyBack(lpArea);
    }
    else {
        mail->setText(lpArea);
    }

    PGPFreeData(lpArea);
    return true;
}


////////////////////////////////////////////////////////////////////////
// PGP
bool Pgpb2::signing(HWND hWnd, PGPContextRef context)
{
    // "From"wb_ mailaddress 𒊏oA|C^XgɊi[B-------------
    string from = mail->getHeader("From");

    CPointerList lstAddr;
    addAddressList(lstAddr, from);

    // i[ mailaddress Ƃ return -------------
    CPointerItem* pItem = lstAddr.GetTop();
    if (pItem == NULL) {
        return false;
    }

    // e mailaddress ɑΉL[܂Ƃ߂Ēo -------------
    PGPKeySetRef foundUserKeys = NULL;
    if (!getKeySet(pItem, context, foundUserKeys)) {
        return false;
    }

    // Passphrase ͂_CAO\B -------------
    PGPError err = kPGPError_NoErr;
    PGPKeyRef signingKey = kInvalidPGPKeyRef;
    PGPUInt32 initialValue = (pgpmime) ? TRUE : FALSE;
    PGPUInt32 resultValue;
    char *lpPassphrase = NULL;
    err = PGPSigningPassphraseDialog(
            context,
            foundUserKeys,
            &signingKey,
            PGPOUIOutputPassphrase(context, &lpPassphrase),
            PGPOUIParentWindowHandle(context, hWnd),
            PGPOUIVerifyPassphrase(context, TRUE),
            PGPOUIDialogOptions(context,
                PGPOUICheckbox(context, 1, "PGP/MIME_RFC2015", NULL, initialValue, &resultValue,
                    PGPOLastOption(context)),
                PGPOLastOption(context)),
            PGPOLastOption(context)
            );

    if (IsPGPError(err)) {
        if (PGPKeySetRefIsValid(foundUserKeys)) {
            PGPFreeKeySet(foundUserKeys);
        }
        return false;
    }

    pgpmime = (resultValue == TRUE);
    string text = mail->getPgpOriginalText(hWnd, pgpmime);
    if (text.size() == 0) {
        return false;
    }
    /*
        FILE* fp;
        fp = fopen("E:\\syou\\mail1.txt", "wb");
        fwrite(text.c_str(), text.size(), 1, fp);
        fclose(fp);
    //*/
    LPSTR lpArea = NULL;
    PGPSize outputSize = 0;
    PGPOptionListRef encodeOptionList;
    err = PGPBuildOptionList(
            context,
            &encodeOptionList,
            PGPOInputBuffer(context, text.c_str(), text.size()),
            PGPOAllocatedOutputBuffer(context, reinterpret_cast<void**>(&lpArea), MAX_PGPInt32, &outputSize),
            PGPOVersionString(context, version.c_str()),
            PGPOSignWithKey(context, signingKey,
                PGPOPassphrase(context, lpPassphrase),
                PGPOLastOption(context)),
            PGPOLastOption(context)
            );
    if (IsPGPError(err)) {
        return false;
    }

    if (pgpmime) {
        err = PGPAppendOptionList(
                encodeOptionList,
                PGPOArmorOutput(context, TRUE),
                PGPODetachedSig(context,
                    PGPOLastOption(context)),
                PGPOLastOption(context)
                );
    }
    else {
        err = PGPAppendOptionList(
                encodeOptionList,
                PGPOClearSign(context, TRUE),
                PGPOLastOption(context)
                );
    }

    if (IsPGPError(err)) {
        return false;
    }

    err = PGPEncode(context, encodeOptionList, PGPOLastOption(context));

    PGPFreeData(lpPassphrase);
    if (PGPOptionListRefIsValid(encodeOptionList)) {
        PGPFreeOptionList(encodeOptionList);
    }
    if (IsPGPError(err) || lpArea == NULL) {
        if (PGPKeySetRefIsValid(foundUserKeys)) {
            PGPFreeKeySet(foundUserKeys);
        }
        return false;
    }

    if (pgpmime) {
        char szBoundary[1024];
        char szData[8192];
        char szHash[20];
        time_t t;

        if (!getHashAlgorithm(signingKey, szHash)) {
            return FALSE;
        }

        time(&t);
        sprintf(szBoundary, "===[PGP/MIME_RFC2015]===%08X.%04X===", (DWORD)t, &t);
        sprintf(szData, "multipart/signed;\r\n boundary=\"%s\";\r\n protocol=\"application/pgp-signature\"; micalg=pgp-%s",
            szBoundary, szHash);
        mail->setHeader("Content-Type", szData);
        mail->setHeader("Content-Transfer-Encoding", "7bit");
        mail->clearBody();

        BkMail* child1 = mail->setChild(new BkMail());
        child1->fromString(text);

        BkMail* child2 = mail->addChild(new BkMail());
        child2->setHeader("Content-Type", "application/pgp-signature");
        child2->setHeader("Content-Transfer-Encoding", "7bit");
        child2->pushBodyBack(lpArea);
    }
    else {
        mail->setText(lpArea);
    }

    PGPFreeData(lpArea);
    if (PGPKeySetRefIsValid(foundUserKeys)) {
        PGPFreeKeySet(foundUserKeys);
    }

    return true;
}



////////////////////////////////////////////////////////////////////////
// PGPÍ
bool Pgpb2::encryptSigning(HWND hWnd, PGPContextRef context)
{
    string to = mail->getHeader("To");
    string cc = mail->getHeader("Cc");
    string bcc = mail->getHeader("Bcc");
    string from = mail->getHeader("From");

    CPointerList lstToAddr;
    CPointerList lstFromAddr;
    addAddressList(lstToAddr, to);
    addAddressList(lstToAddr, cc);
    addAddressList(lstToAddr, bcc);
    addAddressList(lstFromAddr, from);

    CPointerItem* pToItem = lstToAddr.GetTop();
    CPointerItem* pFromItem = lstFromAddr.GetTop();
    if (pToItem == NULL || pFromItem == NULL) {
        return false;
    }

    PGPKeySetRef foundToUserKeys = NULL;
    PGPKeySetRef foundFromUserKeys = NULL;
    if (!getKeySet(pToItem, context, foundToUserKeys) ||  !getKeySet(pFromItem, context, foundFromUserKeys)) {
        return false;
    }

    PGPError err = kPGPError_NoErr;
    PGPKeySetRef encryptKeys = NULL;
    PGPUInt32 initialValue = (pgpmime) ? TRUE : FALSE;
    PGPUInt32 resultValue;
    err = PGPRecipientDialog(
            context,
            foundToUserKeys,
            TRUE,
            &encryptKeys,
            PGPOUIParentWindowHandle(context, hWnd),
            PGPOUIDialogOptions(context,
                PGPOUICheckbox(context, 1, "PGP/MIME_RFC2015", "", initialValue, &resultValue,
                    PGPOLastOption(context)),
                PGPOLastOption(context)),
            PGPOLastOption(context)
            );

    if (IsPGPError(err)) {
        if (PGPKeySetRefIsValid(foundToUserKeys)) {
            PGPFreeKeySet(foundToUserKeys);
        }
        if (PGPKeySetRefIsValid(foundFromUserKeys)) {
            PGPFreeKeySet(foundFromUserKeys);
        }
        return false;
    }

    PGPKeyRef signingKey = kInvalidPGPKeyRef;
    LPSTR lpPassphrase = NULL;
    err = PGPSigningPassphraseDialog(
            context,
            foundFromUserKeys,
            &signingKey,
            PGPOUIOutputPassphrase(context, &lpPassphrase),
            PGPOUIParentWindowHandle(context, hWnd),
            PGPOUIVerifyPassphrase(context, TRUE),
            PGPOLastOption(context)
            );

    if (IsPGPError(err)) {
        if (PGPKeySetRefIsValid(foundToUserKeys)) {
            PGPFreeKeySet(foundToUserKeys);
        }
        if (PGPKeySetRefIsValid(foundFromUserKeys)) {
            PGPFreeKeySet(foundFromUserKeys);
        }
        return false;
    }

    pgpmime = (resultValue == TRUE);
    string text = mail->getPgpOriginalText(hWnd, pgpmime);
    if (text.size() == 0) {
        return false;
    }

    LPSTR lpArea = NULL;
    PGPSize outputSize = 0;
    err = PGPEncode(
            context,
            PGPOInputBuffer(context, text.c_str(), text.size()),
            PGPOAllocatedOutputBuffer(context, reinterpret_cast<void**>(&lpArea), MAX_PGPInt32, &outputSize),
            PGPOVersionString(context, version.c_str()),
            PGPOEncryptToKeySet(context, encryptKeys),
            PGPOSignWithKey(context, signingKey,
                PGPOPassphrase(context, lpPassphrase),
                PGPOLastOption(context)),
            PGPOArmorOutput(context, TRUE),
            PGPOLastOption(context)
            );

    if (PGPKeySetRefIsValid(foundToUserKeys)) {
        PGPFreeKeySet(foundToUserKeys);
    }
    if (PGPKeySetRefIsValid(foundFromUserKeys)) {
        PGPFreeKeySet(foundFromUserKeys);
    }
    if(PGPKeySetRefIsValid(encryptKeys)) {
        PGPFreeKeySet(encryptKeys);
    }
    if (IsPGPError(err) || lpArea == NULL) {
        return false;
    }

    if (pgpmime) {
        char szBoundary[1024];  // MIMEboundary ؂蕶
        char szData[8192];
        time_t t;
        time(&t);   // ݂̎擾 boundaryɖߍ
        sprintf(szBoundary, "===[PGP/MIME_RFC2015]===%08X.%04X===", (DWORD)t, &t);
        sprintf(szData, "multipart/encrypted;\r\n boundary=\"%s\";\r\n protocol=\"application/pgp-encrypted\"", szBoundary);
        mail->setHeader("Content-Type", szData);
        mail->setHeader("Content-Transfer-Encoding", "7bit");
        mail->clearBody();

        BkMail* child1;
        child1 = mail->setChild(new BkMail());
        child1->setHeader("Content-Type", "application/pgp-encrypted");
        child1->setHeader("Content-Transfer-Encoding", "7bit");
        child1->pushBodyBack("Version: 1\r\n");

        BkMail* child2;
        child2 = mail->addChild(new BkMail());
        child2->setHeader("Content-Type", "application/octet-stream");
        child2->setHeader("Content-Transfer-Encoding", "7bit");
        child2->pushBodyBack(lpArea);
    }
    else {
        mail->setText(lpArea);
    }

    PGPFreeData(lpArea);

    return true;
}

/*
////////////////////////////////////////////////////////////////////////
// PGPJYt
bool Pgpb2::publickey(HWND hWnd, PGPContextRef context)
{
    //CBkMail mail(hWnd);
    mail2 = new CBkMail(hWnd);

    PGPKeySetRef defaultKeyRing = NULL;
    PGPError err = PGPOpenDefaultKeyRings(context, kPGPKeyRingOpenFlags_Mutable, &defaultKeyRing);
    if (IsPGPError(err)) {
        return false;
    }

    PGPKeySetRef publicKey = NULL;
    PGPUInt32 initialValue = m_bPGPMIME;
    err = PGPRecipientDialog(
            context,
            defaultKeyRing,
            TRUE,
            &publicKey,
            PGPOUIParentWindowHandle(context, hWnd),
            PGPOLastOption(context)
            );
    if (IsPGPError(err)) {
        return false;
    }

    LPSTR lpArea = NULL;
    PGPExportFormat exportformat = kPGPExportFormat_Basic;
    PGPSize outputSize = 0;
    err = PGPExportKeySet(
            publicKey,
            PGPOAllocatedOutputBuffer(context, reinterpret_cast<void**>(&lpArea), MAX_PGPInt32, &outputSize),
            PGPOExportFormat(context, exportformat),
            PGPOVersionString(context, version.c_str()),
            PGPOExportPrivateKeys(context, FALSE),
            PGPOLastOption(context)
            );
    if (IsPGPError(err)) {
        return false;
    }

    LPSTR name = NULL;
    PGPSize namelen = 0;
    PGPGetPrimaryUserIDNameBuffer(publicKey, namelen, name, &namelen);
    name = new char[namelen+1];
    PGPGetPrimaryUserIDNameBuffer(publicKey, namelen, name, &namelen);
    LPSTR paramater = new char[namelen + 32];
    sprintf(paramater, "application/pgp-keys; %s", name);

    LPSTR lpTxt = mail2->GetPGPOriginalText(TRUE);
    if (lpTxt == NULL) {
        return false;
    }

    char szBoundary[1024];  // MIMEboundary ؂蕶
    char szData[8192];
    time_t t;
    time(&t);   // ݂̎擾 boundaryɖߍ
    sprintf(szBoundary, "===[PGP/MIME_RFC2015]===%08X.%04X===", (DWORD)t, &t);
    sprintf(szData, "multipart/mixed;\r\n boundary=\"%s\";\r\n", szBoundary);
    mail2->SetHeader("Content-Type", szData);
    mail2->SetHeader("Content-Transfer-Encoding", "7bit\r\n");
    mail2->EmptyBody();

    CBkMailPartPtr bmpContent;
    bmpContent = mail2->SetChild(new CMIMEItem());
    bmpContent->FromString(lpTxt);

    CBkMailPartPtr bmpKey;
    bmpKey = mail2->AddChild(new CMIMEItem());
    bmpKey->SetHeader("Content-Type", "application/pgp-keys\r\n");
    bmpKey->SetHeader("Content-Transfer-Encoding", "7bit\r\n");
    bmpKey->AddBodyTail(lpArea);

    //mail2->Commit();
    PGPFreeData(lpArea);
    return true;
}
*/
#pragma warning(pop) /* restore previous warning */
