////////////////////////////////////////////////////////////////////////////////////
//
// main.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: main.cpp,v $
 * Revision 1.22  2000/11/23 07:17:58  syou
 * - DllMainŎqXbh쐬Ă߁APGPB2[hĂȂԂŁA
 *   B2̃vOC̑I_CAOJƂAB2ƂɗĂ
 *   oOCBWindows98ŏ؂̃bZ[WpƂȂĂ̂C
 *   BlXg`ɂȂĂPGP/MIME[̕ƌ؂肭oȂ
 *   oOPgpb2::decodePgpMailPartPgpb2::decodePgpMailPart2ŏCB
 *   Decode܂̃WbŇccłB
 *   PGP/MIMEbZ[W̕ƌ؋@\ǉB،ʂɂẮAƂ肠
 *   PGPlogɕ\悤ɂ݂܂Bo̓bZ[W\[X֒ǕB
 *
 * Revision 1.21  2000/11/08 16:50:47  syou
 * - PGPlogɃbZ[Wo͂邽߂ɁAclass PGPlogVK쐬B
 *   FXKvɂȂ肻Ȃ̂ŁAclass CriticalSectionVK쐬B
 *
 * Revision 1.20  2000/11/07 15:57:20  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 *
 */


#pragma warning(push)
#pragma warning(disable:4101)
#pragma warning(disable:4786)


/////////////////////////////////////////////////////////////////////////////
//
#include "main.h"
#include "PGPlog.h"


/////////////////////////////////////////////////////////////////////////////
//
HINSTANCE instance = NULL;
DWORD tlsid = NULL;
B2API* b2api = NULL;
PGPlog* pgplog = NULL;
Pgpb2Thread* pgpb2Thread = NULL;
stringfr* mes = NULL;


char szIni[_MAX_PATH+2]; // Ini file to save your plugin settings.


/////////////////////////////////////////////////////////////////////////////
// DLL entry point
BOOL APIENTRY DllMain(HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
    instance = (HINSTANCE)hModule;
    switch (ul_reason_for_call)
    {
        case DLL_PROCESS_ATTACH:
            {
                // memory leak p
                _CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF | _CRTDBG_ALLOC_MEM_DF);
                //_CrtSetBreakAlloc(865);  // Yԍ̃mێbreak

                // B2 PlugIn API 
                b2api = B2API::Instance();
                if (b2api == NULL) {
                    return FALSE;
                }

                // PGPlog
                pgplog = PGPlog::Instance();
                if (pgplog == NULL) {
                    return FALSE;
                }

                // PGPsdk libs
                PGPError err = PGPsdkInit();
                if(IsPGPError(err)) {
                    return FALSE;
                }

                // PGPsdk UI libs
                err = PGPsdkUILibInit();
                if (IsPGPError(err)) {
                    return FALSE;
                }

                // TLSm
                tlsid = TlsAlloc();
                if (tlsid == TLS_OUT_OF_INDEXES) {
                    return FALSE;
                }

                // Pgpb2
                pgpb2Thread = new Pgpb2Thread(instance, tlsid);
                if (pgpb2Thread == NULL) {
                    return FALSE;
                }

                //
                mes = new stringfr(instance);
                if (mes == NULL) {
                    return FALSE;
                }
            }
            break;
        case DLL_THREAD_ATTACH:
           break;
        case DLL_THREAD_DETACH:
            break;
        case DLL_PROCESS_DETACH:
            {
                // Pgpb2I
                delete pgpb2Thread;

                // Tls
                TlsFree(tlsid);

                // PGPsdk UI libsI
                PGPsdkUILibCleanup();

                // PGPsdk libsI
                PGPsdkCleanup();

                // PGPlogI
                pgplog->Release();

                //
                delete mes;

                // B2 PlugIn APII
                delete b2api;

            }
            break;
    }
    return TRUE;
}


/////////////////////////////////////////////////////////////////////////////////////////////
// Callbacks from Becky!

#ifdef __cplusplus
extern "C"{
#endif

////////////////////////////////////////////////////////////////////////
// Called when the program is started and the main window is created.
int WINAPI BKC_OnStart()
{
    // Xbhs
    pgpb2Thread->run();
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when the main window is closing.
int WINAPI BKC_OnExit()
{
    // XbhI
    pgpb2Thread->stop();
    // Return -1 if you don't want to quit.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when menu is intialized.
int WINAPI BKC_OnMenuInit(HWND hWnd, HMENU hMenu, int nType)
{
/*
PGPB2_SETTEXT
PGPB2_COMPSETTEMPSOURCE
PGPB2_COMPSETTEMPTEXT*/
    switch (nType) {
    case BKC_MENU_MAIN:
        {
            // Adding menu items
            HMENU hSubMenu = GetSubMenu(hMenu, 4);
            AppendMenu(hSubMenu, MF_SEPARATOR, 0, NULL);

            // Define CmdProc as "void WINAPI CmdProc(HWND, LPARAM)"
            UINT nID = b2api->RegisterCommand(mes->getsfr(44).c_str(), nType, CmdProc5); //"PGPbZ[W̕ƌ (PGP/MIME ̂)"
            AppendMenu(hSubMenu, MF_STRING, nID, mes->getsfr(46).c_str()); //"PGPB2: ƌ (PGP/MIME ̂)..."
            nID = b2api->RegisterCommand(mes->getsfr(45).c_str(), nType, CmdProc6); //"PGPbZ[W̕ƌ (PGP/MIME ȊO)"
            AppendMenu(hSubMenu, MF_STRING, nID, mes->getsfr(47).c_str()); //"PGPB2: ƌ (PGP/MIME ȊO)..."

            //
            DWORD id = b2api->RegisterCommand("", nType, SetSource);
            MessageMap& message = pgpb2Thread->getMessageMap();
            message[PGPB2_SETSOURCE] = id;
            id = b2api->RegisterCommand("", nType, SetTempSource);
            message[PGPB2_SETTEMPSOURCE] = id;
            id = b2api->RegisterCommand("", nType, SetTempText);
            message[PGPB2_SETTEMPTEXT] = id;
        }
        break;
    case BKC_MENU_LISTVIEW:
        break;
    case BKC_MENU_TREEVIEW:
        break;
    case BKC_MENU_MSGVIEW:
        break;
    case BKC_MENU_MSGEDIT:
        break;
    case BKC_MENU_COMPOSE:
        {
            // Sample of adding menu items
            HMENU hSubMenu = GetSubMenu(hMenu, 3);
            AppendMenu(hSubMenu, MF_SEPARATOR, 0, NULL);

            // Define CmdProc as "void WINAPI CmdProc(HWND, LPARAM)"
            UINT nID = b2api->RegisterCommand(mes->getsfr(36).c_str(), nType, CmdProc1); //"PGPÍ"
            AppendMenu(hSubMenu, MF_STRING, nID, mes->getsfr(40).c_str()); //"PGPB2: Í..."
            nID = b2api->RegisterCommand(mes->getsfr(37).c_str(), nType, CmdProc2); //"PGP"
            AppendMenu(hSubMenu, MF_STRING, nID, mes->getsfr(41).c_str()); //"PGPB2: ..."
            nID = b2api->RegisterCommand(mes->getsfr(38).c_str(), nType, CmdProc3); //"PGPƈÍ"
            AppendMenu(hSubMenu, MF_STRING, nID, mes->getsfr(42).c_str()); //"PGPB2: ƈÍ..."

            //nID = b2api->RegisterCommand(mes->getsfr(39).c_str(), nType, CmdProc4); //"PGPJYt"
            //AppendMenu(hSubMenu, MF_STRING, nID, mes->getsfr(43).c_str()); //"PGPB2: J̓Yt..."
            
            DWORD id;
            id = b2api->RegisterCommand("", nType, CompSetSource);
            MessageMap& message = pgpb2Thread->getMessageMap();
            message[PGPB2_COMPSETSOURCE] = id;
            id = b2api->RegisterCommand("", nType, CompSetText);
            message[PGPB2_COMPSETTEXT] = id;
        }
        break;
    case BKC_MENU_COMPEDIT:
        break;
    case BKC_MENU_COMPREF:
        break;
    default:
        break;
    }
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a folder is opened.
int WINAPI BKC_OnOpenFolder(LPCTSTR lpFolderID)
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a mail is selected.
int WINAPI BKC_OnOpenMail(LPCTSTR lpMailID)
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called every minute.
int WINAPI BKC_OnEveryMinute()
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a compose windows is opened.
int WINAPI BKC_OnOpenCompose(HWND hWnd, int nMode/* See COMPOSE_MODE_* in BeckyApi.h */)
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when the composing message is saved.
int WINAPI BKC_OnOutgoing(HWND hWnd, int nMode/* 0:SaveToOutbox, 1:SaveToDraft, 2:SaveToReminder*/)
{
    // Return -1 if you do not want to send it yet.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a key is pressed.
int WINAPI BKC_OnKeyDispatch(HWND hWnd, int nKey/* virtual key code */, int nShift/* Shift state. 0x40=Shift, 0x20=Ctrl, 0x60=Shift+Ctrl, 0xfe=Alt*/)
{
    // Return TRUE if you want to suppress subsequent command associated to this key.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a message is retrieved and saved to a folder
int WINAPI BKC_OnRetrieve(LPCTSTR lpMessage/* Message source*/, LPCTSTR lpMailID/* Mail ID*/)
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a message is spooled
int WINAPI BKC_OnSend(LPCTSTR lpMessage/* Message source */)
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when all messages are retrieved
int WINAPI BKC_OnFinishRetrieve(int nNumber/* Number of messages*/)
{
    // Always return 0.
    return 0;
}


////////////////////////////////////////////////////////////////////////
// Called when plug-in setup is needed.
int WINAPI BKC_OnPlugInSetup(HWND hWnd)
{
    // Return nonzero if you have processed.
    // return 1;
    return 0;
}


////////////////////////////////////////////////////////////////////////
// Called when plug-in information is being retrieved.
typedef struct tagBKPLUGININFO
{
    char szPlugInName[80]; // Name of the plug-in
    char szVendor[80]; // Name of the vendor
    char szVersion[80]; // Version string
    char szDescription[256]; // Short description about this plugin
} BKPLUGININFO, *LPBKPLUGININFO;


int WINAPI BKC_OnPlugInInfo(LPBKPLUGININFO lpPlugInInfo)
{
    /* You MUST specify at least szPlugInName and szVendor.
       otherwise Becky! will silently ignore your plug-in.*/
    strcpy(lpPlugInInfo->szPlugInName, "PGPB2");
    strcpy(lpPlugInInfo->szVendor, "YUGA");
    strcpy(lpPlugInInfo->szVersion, mes->getsfr(32).c_str()); //"version x.xx.x"
    strcpy(lpPlugInInfo->szDescription, mes->getsfr(35).c_str()); //"B2GUIPGPvOCłBPGP version 6.5.x ɑΉ܂B"
    // Always return 0.
    return 0;
}


////////////////////////////////////////////////////////////////////////
//
void WINAPI CmdProc1(HWND hWnd, LPARAM lParam)
{
    // Í
    b2mailstream mailstream(hWnd, ios_base::in);
    PgpMail *mail = new PgpMail();
    char szMimeType[80];
    char szCharset[80];
    try {
        mailstream >> *mail;
        b2api->CompGetCharSet(hWnd, szCharset, 80);
        mail->setText(afterGetText(b2api->CompGetText(hWnd, szMimeType, 80), szCharset));
        if (!pgpb2Thread->pgpEncrypt(hWnd, mail)) {
            b2api->SetMessageText(hWnd, mes->getsfr(48).c_str()); //"xɕPGP͏o܂"
        }
    }
    catch (...) {
    }
    EnableWindow(hWnd, TRUE);
}


void WINAPI CmdProc2(HWND hWnd, LPARAM lParam)
{
    // 
    b2mailstream mailstream(hWnd, ios_base::in);
    PgpMail *mail = new PgpMail();
    char szMimeType[80];
    char szCharset[80];
    try {
        mailstream >> *mail;
        b2api->CompGetCharSet(hWnd, szCharset, 80);
        mail->setText(afterGetText(b2api->CompGetText(hWnd, szMimeType, 80), szCharset));
        /*
        FILE* fp;
        string text(b2api->CompGetSource(hWnd));
        fp = fopen("E:\\syou\\mail0.txt", "wb");
        fwrite(text.c_str(), text.size(), 1, fp);
        fclose(fp);
        //*/
        if (!pgpb2Thread->pgpSigning(hWnd, mail)) {
            b2api->SetMessageText(hWnd, mes->getsfr(48).c_str()); //"xɕPGP͏o܂"
        }
    }
    catch (...) {
    }
}


void WINAPI CmdProc3(HWND hWnd, LPARAM lParam)
{
    // ƈÍ
    b2mailstream mailstream(hWnd, ios_base::in);
    PgpMail *mail = new PgpMail();
    char szMimeType[80];
    char szCharset[80];
    try {
        mailstream >> *mail;
        b2api->CompGetCharSet(hWnd, szCharset, 80);
        mail->setText(afterGetText(b2api->CompGetText(hWnd, szMimeType, 80), szCharset));
        if (!pgpb2Thread->pgpEncryptSigning(hWnd, mail)) {
            b2api->SetMessageText(hWnd, mes->getsfr(48).c_str()); //"xɕPGP͏o܂"
        }
    }
    catch (...) {
    }
}

/*
void WINAPI CmdProc4(HWND hWnd, LPARAM lParam)
{
    // JYt
    b2mailstream mailstream(hWnd, ios_base::in);
    PgpMail *mail = new PgpMail();
    mailstream >> *mail;
    try {
        if (!pgpb2Thread->pgpPublickey(hWnd, mail)) {
            b2api->SetMessageText(hWnd, mes->getsfr(48).c_str()); //"xɕPGP͏o܂"
        }
    }
    catch (...) {
    }
}
*/

void WINAPI CmdProc5(HWND hWnd, LPARAM lParam)
{
    // ƌ PGP MIME
    b2mailstream mailstream(b2api->GetCurrentMail(), ios_base::in);
    PgpMail *mail = new PgpMail();
    try {
        mailstream >> *mail;
        if (!pgpb2Thread->pgpDecodePgpMime(hWnd, mail)) {
            b2api->SetMessageText(hWnd, mes->getsfr(48).c_str()); //"xɕPGP͏o܂"
        }
    }
    catch (...) {
    }
}


void WINAPI CmdProc6(HWND hWnd, LPARAM lParam)
{
    // ƌ not PGP MIME
    b2mailstream mailstream(b2api->GetCurrentMail(), ios_base::in);
    PgpMail *mail = new PgpMail();
    char szMimeType[80];
    char szCharset[80];
    try {
        mailstream >> *mail;
        b2api->GetCharSet(b2api->GetCurrentMail(), szCharset, 80);
        mail->setText(afterGetText(b2api->GetText(szMimeType, 80), szCharset));
        if (!pgpb2Thread->pgpDecodeNotPgpMime(hWnd, mail)) {
            b2api->SetMessageText(hWnd, mes->getsfr(48).c_str()); //"xɕPGP͏o܂"
        }
    }
    catch (...) {
    }
}


void WINAPI SetSource(HWND hWnd, LPARAM lParam)
{
    b2mailstream mailstream(b2api->GetCurrentMail(), ios_base::out);
    PgpMail *mail = pgpb2Thread->getMail();
    try {
        mailstream << *mail;
        mailstream.flush();
    }
    catch (...) {
    }
}


void WINAPI SetTempSource(HWND hWnd, LPARAM lParam)
{
    b2mailstream mailstream("TEMP", ios_base::out);
    PgpMail *mail = pgpb2Thread->getMail();
    try {
        mailstream << *mail;
        mailstream.flush();
    }
    catch (...) {
    }
}


void WINAPI CompSetSource(HWND hWnd, LPARAM lParam)
{
    b2mailstream mailstream(hWnd, ios_base::out);
    PgpMail *mail = pgpb2Thread->getMail();
    try {
        EnableWindow(hWnd, TRUE);
        /*
        FILE* fp;
        string text = mail->toString();
        fp = fopen("E:\\syou\\mail2.txt", "wb");
        fwrite(text.c_str(), text.size(), 1, fp);
        fclose(fp);
        //*/
        mailstream << *mail;
        mailstream.flush();
        b2api->Command(hWnd, "TextTop");
    }
    catch (exception& e) {
        LPCTSTR m = e.what();
    }
}


void WINAPI CompSetText(HWND hWnd, LPARAM lParam)
{
    char szCharset[80];
    PgpMail *mail = pgpb2Thread->getMail();
    b2api->GetCharSet(NULL, szCharset, 80);
    b2api->CompSetText(hWnd, 0, preSetText(mail->getText(), szCharset).c_str());
}


void WINAPI SetTempText(HWND hWnd, LPARAM lParam)
{
    char szCharset[80];
    PgpMail *mail = pgpb2Thread->getMail();
    b2api->GetCharSet(NULL, szCharset, 80);
    b2api->SetText(-2, preSetText(mail->getText(), szCharset).c_str());
}


#ifdef __cplusplus
}
#endif


////////////////////////////////////////////////////////////////////////
//
string afterGetText(const string& text, const string& charset)
{
    if ((charset.size() && stricmp(charset.c_str(), "ISO-2022-JP") == 0) || (charset.empty() && GetACP() == 932)) {
        LPSTR temp = b2api->ISO_2022_JP(text.c_str(), TRUE);
        string out(temp);
        b2api->Free(temp);
        return out;
    }
    return text;
}


string preSetText(const string& text, const string& charset)
{
    if (charset.size() && stricmp(charset.c_str(), "ISO-2022-JP") == 0) {
        LPSTR temp = b2api->ISO_2022_JP(text.c_str(), FALSE);
        string out(temp);
        b2api->Free(temp);
        return out;
    }
    return text;
}


#pragma warning(pop) /* restore previous warning */
