//*********************************************************
//
// stringfr.h
//
// Copyright(c) 1999-2000, Yuganda Tsuki
//
//*********************************************************
/*
 * $Log: stringfr.h,v $
 * Revision 1.1  2000/11/07 15:57:20  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 */

#pragma once


#include <string>
#include <winuser.h>
#include "B2API.h"


///////////////////////////////////////////////////////////////////////////
//
using namespace std;


template< class _E, class _Tr = char_traits<_E>, class _A = allocator<_E> >
class basic_stringfr : public basic_string<_E, _Tr, _A>
{
public:
    explicit basic_stringfr(HINSTANCE initInstance, DWORD id = 0);
    basic_stringfr<_E, _Tr, _A>& getsfr(DWORD id);
    basic_stringfr<_E, _Tr, _A>& utf8();
private:
    HINSTANCE instance;
    B2API* _B2;
};


template< class _E, class _Tr, class _A > inline
    basic_stringfr<_E, _Tr, _A>::basic_stringfr(HINSTANCE initInstance, DWORD id)
    : basic_string<_E, _Tr, _A>()
        {instance = initInstance;
        _B2 = B2API::Instance();
        if (id) {
            getsfr(id); } }


template< class _E, class _Tr, class _A > inline
    basic_stringfr<_E, _Tr, _A>& basic_stringfr<_E, _Tr, _A>::getsfr(DWORD id)
        {int len = 0;
        int size = 0;
        _E* str = NULL;
        while (size - len <= sizeof(_E))
            {_E* old_str = str;
            size += 256*sizeof(_E);
            str = reinterpret_cast<_E*>(realloc(str, size));
            if (str == NULL)
                {if (old_str)
                    free(old_str);
                return *this; }
            len = ::LoadString(instance, id, str, size); }
        assign(str);
        free(str);
        return *this; }

template< class _E, class _Tr, class _A > inline
    basic_stringfr<_E, _Tr, _A>& basic_stringfr<_E, _Tr, _A>::utf8()
        {_E* out = NULL;
        out = _B2->UTF_8(c_str(), TRUE);
        if (out) {
            _E* temp = out;
            assign(temp);
            _B2->Free(out); }
        return *this; }

#ifdef UNICODE
typedef basic_stringfr<wchar_t> stringfr;
#else
typedef basic_stringfr<char> stringfr;
#endif

